#!/usr/bin/perl -w
use IO::Socket;
use IO::Select;
use strict;

#####################
# ݒ
my $restrictserver  = "chaos loki iris ----";
my $modifyleveldesc = 1;
my $filterid        = "Taizou Son";
#
#####################

my $HEADER_SERVER    = "RO-GPS/S04";
my $HEADER_CLIENT    = "RO-GPS/C04";
my $APPLI_VER        = "RO_GPS_PROXY_a0.03";

my $listenport    = shift;
my $maxretry      = 3;
my $retryinterval = 120;
my $timeout       = 10;

my %servers;
while($#ARGV>0) {
	my $hash;
	my $servaddr = shift;
	if($servaddr !~ /:[0-9]+$/){
		$servaddr .= ":5963";
	}
	my %servdesc = (
		descr => shift,
		lastconn => 0,
		failcount => 0,
		up => 0,
		);
	$servers{$servaddr} = {%servdesc};
}

my $listener = IO::Socket::INET->new(
					Listen    => SOMAXCONN,
					LocalPort => $listenport,
					Proto     => 'tcp',
					Reuse     => 1,
					# ZLeBIɖN\邽,
					# ȉ̍sRgAEgꍇ͏[ӂ邱.
					LocalAddr => "localhost",
					);

if( ! $listener ) {
	die "listen ł܂. $!\n";
}

my $selector = IO::Select->new;
$selector->add($listener);

$SIG{PIPE} = sub{
    print "SIGPIPE Lb`. s܂\n";
};

my @peers;
my @msg_complete;

my %servers_up;
my %clients_up;

while(1){
	foreach my $servaddr(keys %servers){
		if(!($servers{$servaddr}->{up})
			and (time() - $servers{$servaddr}->{lastconn} > $retryinterval)) {
			print "$servaddr ɐڑ܂.\n";
			my $servsock = IO::Socket::INET->new($servaddr);
			if(!$servsock){
				print "$servaddr ɐڑł܂.\n";
				$servers{$servaddr}->{lastconn} = time();
				$servers{$servaddr}->{failcount} += 1;
				if($servers{$servaddr}->{failcount} >= $maxretry) {
					print "$servaddr ւ̐ڑA $maxretry 񎸔s܂.\n";
					delete $servers{$servaddr};
				}
			} else {
				$selector->add($servsock);
				
				my $fd = $servsock->fileno;
				print "$servaddr ɐڑ܂. ($fd)\n";
				
				$peers[$fd]{type}   = 0;
				$peers[$fd]{addr}   = $servaddr;
				$peers[$fd]{buffer} = "";
				
				$servers_up{$fd}=$servsock;
				$servers{$servaddr}->{up} = 1;
			}
		}
	}
	
	my @active_socks = $selector->can_read($timeout);
	foreach my $sock(@active_socks){
		if($sock == $listener){
			my $new_client = $listener->accept;
		    $new_client->autoflush(1);
		    $selector->add($new_client);
			
			my $fd = $new_client->fileno;
			print "NCAg $fd ڑ܂.\n";
			
			$peers[$fd]{type}   = 1;
			$peers[$fd]{buffer} = "";
			
			$clients_up{$fd}=$new_client;
		} else {
			my $buf;
			my $fd = $sock->fileno;
		    $sock->sysread($buf,1024);
		    if($buf){
				$peers[$fd]{buffer} .= $buf;
				
				if( $buf =~ /\002/ ) {
					push @msg_complete, $fd;
				}
		    } else {
				if($peers[$fd]{type} == 0){
					my $servaddr = $peers[$fd]{addr};
					print "T[o[ $servaddr ";
					$servers{$servaddr}->{lastconn} = time();
					$servers{$servaddr}->{failcount} = 0;
					$servers{$servaddr}->{up} = 0;
					delete $servers_up{$fd};
				} else {
					print "NCAg $fd ";
					delete $clients_up{$fd};
				}
				print "Ƃ̐ڑLZ܂.\n";
				
				$selector->remove($sock);
				$sock->shutdown(2);
				$sock = undef;
		    }
		}
	}
	
	while(my $fd = shift @msg_complete) {
		my $msg;
		$peers[$fd]{buffer} =~ s/^([^\002]*\002)//;
		$msg = $1;
		
		if($peers[$fd]{type}==0) {
			my $linesadd = 0;
			my $servaddr = $peers[$fd]{addr};
			
			my @lines;
			parse_serv_msg($msg, \@lines);
			
			my $mess = "";
			
			foreach my $href(@lines){
				if ( $restrictserver =~ /$href->{serv}/ and ( $filterid ne $href->{ID} ) ){
					$href->{ID} = $servers{$servaddr}->{descr} . "::" . $href->{ID};
					if($modifyleveldesc) {
						my @dummy = split "/" ,$href->{Lv};
						$href->{Lv} = join "/", ( $dummy[1], $dummy[2], $dummy[0] );
					}
					append_serv_msg(\$mess, $href);
					$linesadd++;
				}
			}
			if($mess) {
				$mess = $HEADER_SERVER . "\001" . $linesadd . "\001" . $mess . "\002";
			}
			
			foreach my $client(values %clients_up){
				$client->syswrite($mess);
			}
		} else {
			foreach my $server(values %servers_up){
				$server->syswrite($msg);
			}
		}
	}
}

sub parse_serv_msg{
	my ($msg, $lines) = @_;
	
	$msg =~ s/\002//g;
	@_ = split(/\001/,$msg);
	splice(@_,0,3);
	
	while($#_>0) {
		my $hash;
		@$hash{"ID","serv","name","place","HP","MaxHP","SP","MaxSP","Lv","Mes"} = splice(@_,0,11);
		$hash->{"ID"}    =~ s/^"(.*)"$/$1/g;
		$hash->{"name"}  =~ s/^"(.*)"$/$1/g;
		$hash->{"place"} =~ s/^"(.*)"$/$1/g;
		$hash->{"Lv"}    =~ s/^"(.*)"$/$1/g;
		$hash->{"Mes"}   =~ s/^"(.*)"$/$1/g;
		push @$lines, $hash;
	}
	return;
}

sub append_serv_msg{
	my ($mess, $hash) = @_;
	my $msg;
	
    $hash->{"ID"}    = qq{"$hash->{ID}"};
    $hash->{"name"}  = qq{"$hash->{name}"};
    $hash->{"place"} = qq{"$hash->{place}"};
    $hash->{"Lv"}    = qq{"$hash->{Lv}"};
    $hash->{"Mes"}    = qq{"$hash->{Mes}"};
    @_ = @$hash{"ID","serv","name","place",
	       "HP","MaxHP","SP","MaxSP","Lv","Mes"};
    unshift(@_,($APPLI_VER));
    $msg = join("\001",@_);
	
	if($$mess) {
		$$mess .= "\001";
	}
	$$mess .= $msg;
	return;
}
